
AWSTemplateFormatVersion: 2010-09-09
Description: API Gateway, Lambda, and Dynamo.
Resources:
  BaseLambdaExecutionPolicy:
    Properties:
      Description: Base permissions needed by all lambda functions.
      PolicyDocument:
        Statement:
        - Action:
          - logs:CreateLogGroup
          - logs:CreateLogStream
          - logs:PutLogEvents
          - ec2:CreateNetworkInterface
          - ec2:DescribeNetworkInterfaces
          - ec2:DeleteNetworkInterface
          Effect: Allow
          Resource: '*'
        Version: '2012-10-17'
    Type: AWS::IAM::ManagedPolicy
  MyApiGateway:
    Properties:
      Body:
        basePath: /
        consumes:
        - application/json
        info:
          description: 'The account API.

            '
          version: 1.0
        paths:
          /users/{userId}:
            get:
              description: TBD
              operationId: getUser
              parameters:
              - description: TBD
                format: uuid
                in: path
                name: userId
                required: true
                type: string
              x-amazon-apigateway-integration:
                credentials:
                  Fn::GetAtt:
                  - MyApiGatewayRole
                  - Arn
                httpMethod: POST
                passthroughBehavior: when_no_match
                type: aws_proxy
                uri:
                  Fn::Sub: arn:aws:apigateway:${AWS::Region}:lambda:path/2015-03-31/functions/${UsersHandler.Arn}/invocations
            post:
              description: TBD
              operationId: postUser
              parameters:
              - description: TBD
                format: uuid
                in: path
                name: userId
                required: true
                type: string
              - description: TBD
                in: body
                name: body
                required: true
                schema:
                  properties:
                    email:
                      type: string
                  required:
                  - email
                  type: object
              x-amazon-apigateway-integration:
                credentials:
                  Fn::GetAtt:
                  - MyApiGatewayRole
                  - Arn
                httpMethod: POST
                passthroughBehavior: when_no_match
                type: aws_proxy
                uri:
                  Fn::Sub: arn:aws:apigateway:${AWS::Region}:lambda:path/2015-03-31/functions/${UsersHandler.Arn}/invocations
        produces:
        - application/json
        schemes:
        - https
        swagger: 2.0
      Description: ClimJou's API
      FailOnWarnings: true
      Name:
        Fn::Sub: ${AWS::StackName}
    Type: AWS::ApiGateway::RestApi
  MyApiGatewayDeployment:
    Properties:
      RestApiId:
        Ref: MyApiGateway
      StageName: prod
    Type: AWS::ApiGateway::Deployment
  MyApiGatewayRole:
    Properties:
      AssumeRolePolicyDocument:
        Statement:
        - Action: sts:AssumeRole
          Effect: Allow
          Principal:
            Service: apigateway.amazonaws.com
        Version: '2012-10-17'
      Policies:
      - PolicyDocument:
          Statement:
          - Action:
            - lambda:InvokeFunction
            Effect: Allow
            Resource:
            - Fn::GetAtt:
              - UsersHandler
              - Arn
          Version: '2012-10-17'
        PolicyName: InvokeLambda
    Type: AWS::IAM::Role
  UserTable:
    Properties:
      AttributeDefinitions:
      - AttributeName: user_id
        AttributeType: S
      KeySchema:
      - AttributeName: user_id
        KeyType: HASH
      ProvisionedThroughput:
        ReadCapacityUnits: 5
        WriteCapacityUnits: 5
    Type: AWS::DynamoDB::Table
  UsersHandler:
    Properties:
      Code:
        S3Bucket: climjou-functions
        S3Key: f7e783dd83fdf71269fa51e1d63df894
      Environment:
        Variables:
          USER_DB:
            Fn::Sub: arn:aws:dynamodb:${AWS::Region}:*:table/${UserTable}
      Handler: users-handler.handleHttpRequest
      Role:
        Fn::GetAtt:
        - UsersHandlerRole
        - Arn
      Runtime: nodejs8.10
    Type: AWS::Lambda::Function
  UsersHandlerRole:
    Properties:
      AssumeRolePolicyDocument:
        Statement:
        - Action: sts:AssumeRole
          Effect: Allow
          Principal:
            Service: lambda.amazonaws.com
        Version: '2012-10-17'
      ManagedPolicyArns:
      - Ref: BaseLambdaExecutionPolicy
      Policies:
      - PolicyDocument:
          Statement:
          - Action:
            - dynamodb:GetItem
            Effect: Allow
            Resource:
              Fn::Sub: arn:aws:dynamodb:${AWS::Region}:*:table/${UserTable}
          Version: '2012-10-17'
        PolicyName: getUser
      - PolicyDocument:
          Statement:
          - Action:
            - dynamodb:PutItem
            Effect: Allow
            Resource:
              Fn::Sub: arn:aws:dynamodb:${AWS::Region}:*:table/${UserTable}
          Version: '2012-10-17'
        PolicyName: putUser
    Type: AWS::IAM::Role
